Applicability of Reliable Server Pooling for SCTP-Based Endpoint Mobility
Internet-Draft draft-dreibholz-rserpool-applic-mobility-31
Thomas Dreibholz
Simula Metropolitan Centre for Digital Engineering
Pilestredet 52
0167 Oslo
Norway
dreibh@simula.no
https://www.simula.no/people/dreibh
Jobin Pulinthanath
University of Duisburg-Essen, Institute for Experimental Mathematics
Ellernstraße 29
45326 Essen
Germany
jp@iem.uni-due.de.de
17 September 2022
Internet-Draft
This document describes a novel mobility concept based on a combination of SCTP with Dynamic Address Reconfiguration extension and Reliable Server Pooling (RSerPool).
Introduction
An increasing amount of Internet devices is getting mobile. Therefore, there is a growing demand for software solutions allowing for a seamless handover of communication sessions between multiple networks, e.g. to allow for a laptop or PDA to use a fast Ethernet connection when available, hand over to a WLAN when moving and hand over again to UMTS when the WLAN becomes unreachable - without interrupting the running communication sessions.
Mobility handling is a deficiency of the common IP-based networks. Most of the available solutions are based on the network layer. The disadvantage of such solutions is that fundamental changes in the network infrastructure are needed. Therefore, we propose a new solution based on the upper layers to overcome these disadvantages. In this document, we present our mobility solution based on the SCTP protocol with Dynamic Address Reconfiguration extension and Reliable Server Pooling (RSerPool).
Existing Mobility Solutions
Mobile IP and Mobile IPv6
In the concept of Mobile IP [RFC5944] every node must register to a Home-Agent (HA) in its own home network. Then, the nodes are reachable under their home addresses managed by the HA. When a node leaves its home network, it must also register at a Foreign Agent (FA) in the new network. After that, a tunnel is established between the HA and the FA. Any traffic to the mobile node is then tunnelled by its HA to the FA and forwarded by the FA to the node itself. Clearly, the detour of all traffic via HA and FA is inefficient and results in an increased transmission delay.
Mobile IPv6 [RFC6275] is an extension of Mobile IP. In Mobile IPv6, the FA is not needed. The packets will be tunnelled from the HA to the Gateway Router in the foreign network, which forwards the packets to the endpoint. The inefficiency due to the detour of traffic as described for Mobile IP remains.
SCTP with Dynamic Address Reconfiguration
Using the SCTP protocol (see [RFC4960] together with its Dynamic Address Reconfiguration extension (Add-IP, see [RFC5061]), it is possible for a mobile endpoint to inform its peer on address changes. That is, when a moving mobile client gets in the vicinity of an additional radio station, it sends an "ASCONF Add Address Request" to tell its peer that it is now reachable under an additional network-layer address. After that, the peer endpoint can use this additional address for a new SCTP path. When the first radio station becomes unreachable, the node can send an "ASCONF Delete Address Request" to the peer endpoint. After that, the peer removes the corresponding SCTP path to the unusable network-layer address.
The following two cases for handovers are possible:
- Make-before-Break: An additional SCTP path can be used before the original path becomes unusable. This case is trivial, since there is a continuous connectivity.
- Break-before-Make: The original SCTP path becomes unusable before a new SCTP path can be used. For the case that only one endpoint performs a handover procedure at the same time, the mobile endpoint can always use Add-IP to communicate its new address to its peer endpoint. However, when both endpoints perform a handover simultaneously, no endpoint is able to tell its corresponding peer the new address.
Solutions for Simultaneous Handovers
SCTP with Add-IP and Mobile-IP
Using SCTP with Add-IP and Mobile IP/Mobile IPv6, the ASCONF messages will be sent to the home address of the peer node. That is, even when both nodes are mobile, each endpoint is able to reach its peer endpoint using the corresponding home address. However, this solution still requires the full Mobile IP/Mobile IPv6 infrastructure.
SCTP with Add-IP and RSerPool
Using RSerPool (see [RFC3237], [RFC5351], [RFC5352], [RFC5353], [RFC5354], [RFC5355], [RFC5356], at least one node registers as a Pool Element (PE) at an ENRP server under a Pool Handle (PH) known to both endpoints. Upon handover, it is simply necessary for the PE endpoint to re-register, i.e. to update its registration with its new address. The other endpoint can - in the role of a Pool User (PU) - ask an ENRP server for its peer node's new addresses. After the new address is known, it is able to create a new SCTP path and continue the communication.
The usage of RSerPool to provide support for mobile endpoints provides the following advantages:
- Simplicity: No Mobile IP/Mobile IPv6 infrastructure is needed. In particular, it is not necessary that the providers of used networks (e.g. public WLAN access points, UMTS providers, etc.) provide any support for the mobility solution.
- Efficiency: No tunnelling of traffic is necessary.
- Applicability: All major SCTP implementations already support the Dynamic Address Reconfiguration extension. It is only necessary to provide support for RSerPool, e.g. in the form of a userspace library, which is much easier to deploy than kernel extensions.
- Flexibility: RSerPool provides a complete session layer. That is, providing applications on top of RSerPool makes the support for high availability simple.
A more detailed description of our approach for endpoint mobility, as well as a performance analysis using a prototype implementation, can be found in our paper [LCN2003].
Reference Implementation
The RSerPool reference implementation RSPLIB can be found at [RSerPool-Website]. It supports the functionalities defined by [RFC5351], [RFC5352], [RFC5353], [RFC5354] and [RFC5356] as well as the options [I-D.dreibholz-rserpool-asap-hropt], [I-D.dreibholz-rserpool-enrp-takeover] and [I-D.dreibholz-rserpool-delay]. An introduction to this implementation is provided in [Dre2006].
Testbed Platform
A large-scale and realistic Internet testbed platform with support for the multi-homing feature of the underlying SCTP protocol is NorNet. A description of NorNet is provided in [PAMS2013-NorNet], some further information can be found on the project website [NorNet-Website].
Security Considerations
Security considerations for RSerPool systems are described by [RFC5355].
IANA Considerations
This document introduces no additional considerations for IANA.
References
Normative References
[RFC3237]

Requirements for Reliable Server Pooling
M. Tuexen
Q. Xie
R. Stewart
M. Shore
L. Ong
J. Loughney
M. Stillman
January 2002
RFC 3237
DOI 10.17487/RFC3237
[RFC4960]

Stream Control Transmission Protocol
R. Stewart, Ed.
September 2007
RFC 4960
DOI 10.17487/RFC4960
[RFC5061]

Stream Control Transmission Protocol (SCTP) Dynamic Address Reconfiguration
R. Stewart
Q. Xie
M. Tuexen
S. Maruyama
M. Kozuka
September 2007
RFC 5061
DOI 10.17487/RFC5061
[RFC5944]

IP Mobility Support for IPv4, Revised
C. Perkins, Ed.
November 2010
RFC 5944
DOI 10.17487/RFC5944
[RFC6275]

Mobility Support in IPv6
C. Perkins, Ed.
D. Johnson
J. Arkko
July 2011
RFC 6275
DOI 10.17487/RFC6275
[RFC5351]

An Overview of Reliable Server Pooling Protocols
P. Lei
L. Ong
M. Tuexen
T. Dreibholz
September 2008
RFC 5351
DOI 10.17487/RFC5351
[RFC5352]

Aggregate Server Access Protocol (ASAP)
R. Stewart
Q. Xie
M. Stillman
M. Tuexen
September 2008
RFC 5352
DOI 10.17487/RFC5352
[RFC5353]

Endpoint Handlespace Redundancy Protocol (ENRP)
Q. Xie
R. Stewart
M. Stillman
M. Tuexen
A. Silverton
September 2008
RFC 5353
DOI 10.17487/RFC5353
[RFC5354]

Aggregate Server Access Protocol (ASAP) and Endpoint Handlespace Redundancy Protocol (ENRP) Parameters
R. Stewart
Q. Xie
M. Stillman
M. Tuexen
September 2008
RFC 5354
DOI 10.17487/RFC5354
[RFC5355]

Threats Introduced by Reliable Server Pooling (RSerPool) and Requirements for Security in Response to Threats
M. Stillman, Ed.
R. Gopal
E. Guttman
S. Sengodan
M. Holdrege
September 2008
RFC 5355
DOI 10.17487/RFC5355
[RFC5356]

Reliable Server Pooling Policies
T. Dreibholz
M. Tuexen
September 2008
RFC 5356
DOI 10.17487/RFC5356
[I-D.dreibholz-rserpool-asap-hropt]

Handle Resolution Option for ASAP
Thomas Dreibholz
SimulaMet
6 September 2021
Internet-Draft draft-dreibholz-rserpool-asap-hropt-29
[I-D.dreibholz-rserpool-delay]

Definition of a Delay Measurement Infrastructure and Delay-Sensitive Least-Used Policy for Reliable Server Pooling
Thomas Dreibholz
SimulaMet
Xing Zhou
Hainan University
6 September 2021
Internet-Draft draft-dreibholz-rserpool-delay-28
[I-D.dreibholz-rserpool-enrp-takeover]

Takeover Suggestion Flag for the ENRP Handle Update Message
Thomas Dreibholz
SimulaMet
Xing Zhou
Hainan University
6 September 2021
Internet-Draft draft-dreibholz-rserpool-enrp-takeover-26
Informative References
[Dre2006]

Reliable Server Pooling – Evaluation, Optimization and Extension of a Novel IETF Architecture
ThomasDreibholz
7 March 2007
[LCN2003]

A New Scheme for IP-based Internet Mobility
ThomasDreibholz
AndreasJungmaier
MichaelTüxen
22 October 2003
Proceedings of the 28th IEEE Local Computer Networks Conference(LCN) Pages 99-108, ISBN0-7695-2037-5, DOI10.1109/LCN.2003.1243117
[PAMS2013-NorNet]

Design and Implementation of the NorNet Core Research Testbed for Multi-Homed Systems
ThomasDreibholz
Ernst GunnarGran
27 March 2013
Proceedings of the 3nd International Workshop on Protocols and Applications with Multi-Homing Support(PAMS) Pages 1094-1100, ISBN978-0-7695-4952-1, DOI10.1109/WAINA.2013.71
[RSerPool-Website]

Thomas Dreibholz's RSerPool Page
ThomasDreibholz
2022
[NorNet-Website]

NorNet – A Real-World, Large-Scale Multi-Homing Testbed
Thomas Dreibholz
2022